/* Copyright 2024 by COG9 Enterprises LLC
 * All rights reserved.
 * Title: io.c
 * Author: Jed Marti
 * Description: Process to read stuff and send as a message.
 * Created: Sun Dec 22 15:39:44 2024
 * Revision History:
 */

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>

#include "mqtt.h"

extern uint8_t Noise;

uint8_t isStarted = 0;

void readAndSend(void)
{
  char msg[MAXPATHLEN];
  char *res;

 loop:
  res = fgets(msg, MAXPATHLEN, stdin);
  if (res == NULL)
  {
    fprintf(stderr, "%s:%s:%d Input fails because %s\n", __FILE__, __func__, __LINE__,
	    strerror(errno));
    exit(-1);
  }
  printf("Message %s", msg);
  publishMessage(msg);
  goto loop;
}



void startMessage(void)
{
  pid_t child;

  child = fork();
  if (child == 0)
  {
    readAndSend();
    exit(-1);
  }

  else if (child == -1)
  {
    fprintf(stderr, "%s:%s:%d Message subprocess fails because %s\n", __FILE__, __func__, __LINE__,
	    strerror(errno));
    exit(-1);
  };
  isStarted = 1;
  
  if (Noise > 0) printf("%s:%s:%d message process %d starts\n", __FILE__, __func__, __LINE__,
			child);
}
    
	    
      
// EOF
 
